#!/bin/sh
CPU_DIR="/media/fat/games/Amiga"
CPU68000="ld-linux-armhf.so.3 qemu-system-m68k"
CPU68000_START="qemu_system_test/go"
#CPU68000="musashi_68040_mister"
#CPU68000="musashi_68020_mister"

CORENAME="Minimig"

function KILL_68000CPU
{
    echo "Killing 68000 CPU..."   
    killall $CPU68000
    sleep 1
}

function LOAD_KERNEL_MODULE
{
    if [ -f /sys/kernel/config/device-tree/overlays/minimig/status ]; then
    	echo "Hybrid CPU kernel module alreeady loaded..."
    else
    	echo "Loading hybrid CPU interrupt kernel module..."
    	cd $CPU_DIR
    	cd minimig_module
    	./setup
    fi
}

function START_68000CPU
{
    LOAD_KERNEL_MODULE
    cd $CPU_DIR
    #Use $CPU68000_START if set
    if [ -z "$CPU68000_START" ]; then 
       echo "Starting 68000 CPU : $CPU68000"
       taskset 1 ./$CPU68000&
    else
       echo "Starting 68000 CPU : $CPU68000_START"
       taskset 1 ./$CPU68000_START &
    fi
}
 
TMP=""

[ -f /tmp/CORENAME ] && TMP=$(cat /tmp/CORENAME)
if [ $TMP == $CORENAME ]; then 
    if [ "$1" == "STOP" ]; then 
        KILL_68000CPU
    elif [ "$1" == "START" ]; then
        KILL_68000CPU
        for i in {3..1} 
        do
            echo "Starting in -->$i"
            sleep 1 
        done
    	echo "Turning off UART daemons..." 
    	uartmode 0
        START_68000CPU
    else
        echo "USAGE : 68000.sh [ START | STOP ]"
    fi
else 
    echo "Wrong core name --> $CORENAME"
fi
